Hi Mark,
	This was originally a commentary on the introduction you sent
this morning, but it grew into a stream of thought.  It's a little long,
but I think will help coordinate our thoughts on this proposal.
	Jon
---------------
	I got your suggested first paragraph and I think we can probably
come up with some compromise to make each of us happy.  It is a bad
time to consult with people now since a lot of people are at conferences,
but I will spend as much time as I can with Steve M. and Fred Roberts deciding 
what the emphasis should be.  One thing that Steve has already warned me about
is that lots of people have animation systems and may be proposing to
research ways of incorporating them into curricula.  I've looked at some
of the work out there: Stasko at Georgia Tech (Xtango, Polka), Marc Brown 
(I think he's at Xerox PARC - I got his distinguished dissertation on 
algorithm animation out from the library), and Mark Guzdial at Georgia
Tech (CaMile - web-based tools for the classroom).  Their work is good;
it's important that we emphasize how our work will be different:  Our
strength is not visualization, at least not from my point of view.
Visualization clearly is the prerequisite to play in this game, and
we have that.   However, other people have much more significant
*visualization* systems and may be proposing to research integrating 
them into curricula.  What we have that nobody else has is a 
*computing environment* with interactive visualization capabilities.  
Scheme is the language used by MIT and Berkeley to teach introductory CS, 
and now students have discrete mathematical objects at their fingertips
to experiment with and visualize.  That is a powerful resume that
all other systems (for discrete math) lack, with the possible exception 
of Combinatorica, which requires the purchase of mathematica and doesn't 
let students manipulate their visualizations.  Steve M. encouraged me to 
emphasize this as much as possible.

Two things worry me about the wording of the main objective of the
proposed work in the paragraph you sent:  the emphasis on visualization and the 
the idea that we say that we need to do research in order to 
integrate tools like these into the curriculum. 

I think that the statement that the main objective of the proposal is 
"to research the best ways of integration of...." is too sweeping a statement.
The proposal breaks down nicely into two almost disjoint 
components, K-12, and university-level education, each at a different stage 
of development.  Joe Rosenstein knows exactly what he wants to do in order to 
integrate technology into K-12 education - compile a "book" (web and textbook,
with LINK as the tool illustrating each concept(!)) for K-12 teachers 
and distribute via web and CD-ROM.  He's thought about the idea in 
abstract for a long time, and he laid it out in more concrete form to Steve M. 
and me in Steve's office the other day. He's just waiting for resources.  
I anticipate that he would object to a statement that the main objective of 
the proposed work is to research how to integrate visualization technology
(I could be wrong - I haven't seen him today).

For K-12 education, LINK's advantage is that it's free and portable (or 
at least will become portable) to PCs.  The interface is flexible and
fun to use.  The computing features will probably go largely unused,
at least from the kids' point of view.  At the university level, though,
the advantage isn't great crowd-pleasing visualizations like a true
visualization package would provide.  Our advantage is that, in addition
to providing the required visualization,  we give students the luxury 
of interactive experimentation. 

I think that the term "interactive experimentation" is a nice abstraction 
of what LINK provides that existing systems don't.  For example, Stasko's 
"Polka" system (Polka is an animation system that evolved from XTango) 
recognizes a primitive language of commands like "lineto 20 300."  The 
student writes a program which implements an algorithm and outputs lines 
in this simple language.  Then the student runs the system and is given 
control of a fantastic animation facility which allows the student to 
step forward and backwards through the animation or run it with glorious 
speed.  But this is all "off-line" in the sense that the system only
"knows" pieces of information like "lineto 20 300," etc.  It knows 
nothing of vertices, edges, adjacencies, etc. Running the 
algorithm on another graph (or for that matter trying to do any graph
manipulation at all) requires another run of the student's 
program with different input.  Plus, the speed is gained by utilizing
low-level Xwindows code, making it non-portable.

What I am saying is that to someone who isn't looking at the big 
picture (I hope this doesn't include NSF reviewers!), Polka animations would 
seem *much* more impressive than LINK's.  The reality is that LINK is 
*much* more useful; in fact, it's unfair to draw a comparison between
the two since they are apples and oranges.  LINK is a computing 
environment in which the student can ask questions about algorithms
interactively and receive answers visually.  I want to make sure that
this becomes clear in our proposal.  When I said, "Manipulation of these
models and visualization of the results can lead to deeper understanding
of the problems themselves,"  I really meant it in that order. 
Visualization is little more than "watching TV" unless there is the
capability to ask questions, manipulate models, and try it again.
Our main advantage over the competition, at least in discrete math
applications, is our ability to let students ask questions.
A powerful challenge to LINK would be a combination of the use of LEDA 
to let students develop algorithms quickly, and Polka to visualize
the results.  On the surface, it seems to be a better solution.
LEDA's libraries are much more polished and extentensive than LINK's.
They've been in heavy use for years.  Polka's animations are much faster 
than LINK's.  Why would anyone use LINK?  

The answer to that last question is the computing environment provided by
STk.  This gives the student the ability to participate more in the learning 
process by interactively satisfying doubts and misunderstandings that 
arise during visualization.  This also gives the developer (me, and 
hopefully many others in the future) the ability to give students 
the option of satisfying these doubts without even knowing Scheme.
We can give them mouse-click access to functionality like creating
contrived examples to isolate a particular aspect of some algorithm,
generating large numbers of test instances, extracting induced subgraphs, 
running algorithms on them, and using the results to create new structures.

We should be very careful when mentioning "visualization" in this proposal.
For me, and for many others I would suspect, that term conjures up the
image of fantastic 3-d movies of fluid dynamics or stresses on a bending
wrench (all done on supercomputers).  Joe Flaherty and Frank Luk are
probably very familiar with these.  But visualization in that sense is
definitely not what LINK is all about;  I think we should accompany every
reference to visualization with a reminder that LINK is about asking
questions as well.  I think that an unaccompanied reference to "integration 
of visualization technology" right up front might put the reader on the wrong 
track.

I'll work on a modification and let you know when it's done.  If we
keep iterating for the next few days and Steve M. and Joe R. submit
good comments, the proposal should continue to improve.

-Jon
